All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Metadata |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sas.metadata.remote
Interface Role

All Superinterfaces:
  CMetadata, MdObjectBase, MdObjectBaseUtil, MdObjectBaseXML, java.rmi.Remote, Root, SecondaryType

    public interface Role

extends SecondaryType

This object describes a role of of an object, and the context of the role.

Defined contexts are:

- ContentType
- WA (abbreviation for SAS Data Integration Studio)
- EM (abbreviation for SAS Enterprise Miner)

- For ContentType, valid roles are BASE, NWAY, AGGREGATE, STARFACT, STARTDIM
- For WA, valid roles are Source, Target
- For EM, valid roles are Training

The list of roles will be expanded, along with the list of contexts.

Attributes of Role are:

- `Context`
- `ObjectRole`

Associations of Role are:

- `RoleObject`

## Usage

To create an instance of this Role, use the `factory` create methods.
Example: create a Role with name "Role_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Role myObject = (Role) factory.createComplexMetadataObject(objectStore, "Role_Object", MetadataObjects.ROLE, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

Field Summary
`static java.lang.String` | `ASSOCIATION_ROLEOBJECT_NAME` Constant used for the name of the RoleObject association.
`static java.lang.String` | `ATTRIBUTE_CONTEXT_NAME` Constant used for the name of the Context attribute.
`static java.lang.String` | `ATTRIBUTE_OBJECTROLE_NAME` Constant used for the name of the ObjectRole attribute.

Fields inherited from interface com.sas.metadata.remote.Root
`ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

Fields inherited from interface com.sas.metadata.remote.MdObjectBase
`ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

Method Summary
`java.lang.String` | `getContext()` Gets the `String` value of `Context`
`int` | `getContextMaxLength()` Gets the maximum length of `Context`
`int` | `getContextState()` Gets the Metadata State of `Context`
`java.lang.String` | `getObjectRole()` Gets the `String` value of `ObjectRole`
`int` | `getObjectRoleMaxLength()` Gets the maximum length of `ObjectRole`
`int` | `getObjectRoleState()` Gets the Metadata State of `ObjectRole`
`DataTable` | `getRoleObject()` Gets the `DataTable` for `RoleObject`
`AssociationList` | `getRoleObjects()` Gets the AssociationList of `RoleObjects`
`AssociationList` | `getRoleObjects(boolean fGoToServer)` Gets the Associationlist of `RoleObjects`
`void` | `initializePredObjects()` (S) Adds the Associated objects to the predObjects which are: `RoleObject`
`void` | `initializeRequiredObjects()` (S) This initializes the Required Objects(Roles) which are: `RoleObject`
`void` | `setContext(java.lang.String inContext)` Sets the `Context` value and sets the state to MetadataState.LOCAL.
`void` | `setContext(java.lang.String inContext, int state)` Sets the `Context` Metadata State.
`void` | `setContextState(int state)` Sets the Metadata State of `Context`.
`void` | `setObjectRole(java.lang.String inObjectRole)` Sets the `ObjectRole` value and sets the state to MetadataState.LOCAL.
`void` | `setObjectRole(java.lang.String inObjectRole, int state)` Sets the `ObjectRole` Metadata State.
`void` | `setObjectRoleState(int state)` Sets the Metadata State of `ObjectRole`.
`void` | `setRoleObject(DataTable inObject)` Sets the `RoleObjects` list 0th element to be `inObject`.
`void` | `setRoleObjects(AssociationList list)` Sets the `RoleObjects` list to be `list`.
`void` | `setRoleObjects(AssociationList list, int state)` Sets the `RoleObjects` list to be `list`.

Methods inherited from interface com.sas.metadata.remote.Root
`getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML
`closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil
`addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

Methods inherited from interface com.sas.metadata.remote.MdObjectBase
`addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

Field Detail

### ATTRIBUTE_CONTEXT_NAME

    static final java.lang.String ATTRIBUTE_CONTEXT_NAME

  Constant used for the name of the Context attribute.

  Context: This is the context or category of the role. Valid values include EM, WA and ContentType.

  See Also:
    Constant Field Values

### ATTRIBUTE_OBJECTROLE_NAME

    static final java.lang.String ATTRIBUTE_OBJECTROLE_NAME

  Constant used for the name of the ObjectRole attribute.

  ObjectRole: This attribute describes the role in a particular context. For example, if the context is ContentType, the ObjectRole can be Summary or Base. If the context is WA, the ObjectRole can be Source or Target.

  See Also:
    Constant Field Values

### ASSOCIATION_ROLEOBJECT_NAME

    static final java.lang.String ASSOCIATION_ROLEOBJECT_NAME

  Constant used for the name of the RoleObject association.

  RoleObject: The object that is playing this particular role.

  See Also:
    Constant Field Values

Method Detail

### initializeRequiredObjects

    void initializeRequiredObjects()
                                   throws java.rmi.RemoteException

  (S) This initializes the Required Objects(Roles) which are:
  `RoleObject`

  Specified by:
    `initializeRequiredObjects` in interface `MdObjectBaseUtil`
  Specified by:
    `initializeRequiredObjects` in interface `Root`
  Specified by:
    `initializeRequiredObjects` in interface `SecondaryType`
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### initializePredObjects

    void initializePredObjects()
                               throws java.rmi.RemoteException

  (S) Adds the Associated objects to the predObjects which are:
  `RoleObject`

  Specified by:
    `initializePredObjects` in interface `MdObjectBase`
  Specified by:
    `initializePredObjects` in interface `Root`
  Specified by:
    `initializePredObjects` in interface `SecondaryType`
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getContext

    java.lang.String getContext()
                                throws java.rmi.RemoteException

  Gets the `String` value of `Context`

  Returns:
    The `Context`
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getContextState

    int getContextState()
                        throws java.rmi.RemoteException

  Gets the Metadata State of `Context`

  Returns:
    The State.
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getContextMaxLength

    int getContextMaxLength()
                            throws java.rmi.RemoteException

  Gets the maximum length of `Context`

  Returns:
    The max size
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getObjectRole

    java.lang.String getObjectRole()
                                   throws java.rmi.RemoteException

  Gets the `String` value of `ObjectRole`

  Returns:
    The `ObjectRole`
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getObjectRoleState

    int getObjectRoleState()
                           throws java.rmi.RemoteException

  Gets the Metadata State of `ObjectRole`

  Returns:
    The State.
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getObjectRoleMaxLength

    int getObjectRoleMaxLength()
                               throws java.rmi.RemoteException

  Gets the maximum length of `ObjectRole`

  Returns:
    The max size
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getRoleObjects

    AssociationList getRoleObjects()
                                   throws java.rmi.RemoteException,
                                          MdException

  Gets the AssociationList of `RoleObjects`

  Returns:
    Returns the AssociationList of `RoleObjects` which can be of type:
    DataTable
    ExternalTable
    RelationalTable
    PhysicalTable
    WorkTable
    SecuredTable
    QueryTable
    JoinTable
    TableCollection
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException`

### getRoleObject

    DataTable getRoleObject()
                            throws java.rmi.RemoteException,
                                   MdException

  Gets the `DataTable` for `RoleObject`

  Returns:
    The `DataTable` ( `null` if not set) of `RoleObject`which can be of type:
    DataTable
    ExternalTable
    RelationalTable
    PhysicalTable
    WorkTable
    SecuredTable
    QueryTable
    JoinTable
    TableCollection
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException` - If error getting/setting part of the object.

### getRoleObjects

    AssociationList getRoleObjects(boolean fGoToServer)
                                   throws java.rmi.RemoteException,
                                          MdException

  Gets the Associationlist of `RoleObjects`

  Parameters:
    `fGoToServer` - boolean Get the value from the server.
  Returns:
    Returns the AssociationList of `RoleObjects` which can be of type:
    DataTable
    ExternalTable
    RelationalTable
    PhysicalTable
    WorkTable
    SecuredTable
    QueryTable
    JoinTable
    TableCollection
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException` - If error getting/setting part of the object.

### setContext

    void setContext(java.lang.String inContext)
                    throws java.rmi.RemoteException

  Sets the `Context` value and sets the state to MetadataState.LOCAL.

  Parameters:
    `inContext` - String
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setContext

    void setContext(java.lang.String inContext,
                    int state)
                    throws java.rmi.RemoteException

  Sets the `Context` Metadata State.

  Parameters:
    `inContext` - String
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setContextState

    void setContextState(int state)
                         throws java.rmi.RemoteException

  Sets the Metadata State of `Context`.

  Parameters:
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setObjectRole

    void setObjectRole(java.lang.String inObjectRole)
                       throws java.rmi.RemoteException

  Sets the `ObjectRole` value and sets the state to MetadataState.LOCAL.

  Parameters:
    `inObjectRole` - String
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setObjectRole

    void setObjectRole(java.lang.String inObjectRole,
                       int state)
                       throws java.rmi.RemoteException

  Sets the `ObjectRole` Metadata State.

  Parameters:
    `inObjectRole` - String
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setObjectRoleState

    void setObjectRoleState(int state)
                            throws java.rmi.RemoteException

  Sets the Metadata State of `ObjectRole`.

  Parameters:
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setRoleObjects

    void setRoleObjects(AssociationList list)
                        throws java.rmi.RemoteException

  Sets the `RoleObjects` list to be `list`. Object of which can be of type:
  DataTable
  ExternalTable
  RelationalTable
  PhysicalTable
  WorkTable
  SecuredTable
  QueryTable
  JoinTable
  TableCollection

  Parameters:
    `list` - AssociationList
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setRoleObjects

    void setRoleObjects(AssociationList list,
                        int state)
                        throws java.rmi.RemoteException

  Sets the `RoleObjects` list to be `list`. Object of which can be of type:
  DataTable
  ExternalTable
  RelationalTable
  PhysicalTable
  WorkTable
  SecuredTable
  QueryTable
  JoinTable
  TableCollection

  Parameters:
    `list` - AssociationList
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setRoleObject

    void setRoleObject(DataTable inObject)
                       throws java.rmi.RemoteException

  Sets the `RoleObjects` list 0th element to be `inObject`.

  Parameters:
    `inObject` - DataTable
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Metadata |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009 SAS Institute Inc. All Rights Reserved.